/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB(c) Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 3.15.0
        Device            :  PIC16F1769
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.20
*/

/*
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
*/

#include "mcc.h"
#include "globals.h"
#include "task_scheduler.h"

uint8_t TaskCounter=0;

/*
                         Main application
 */
void main(void)
{
  // initialize the device
  SYSTEM_Initialize();

  // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
  // Use the following macros to:

  // Enable the Global Interrupts
  //INTERRUPT_GlobalInterruptEnable();

  // Enable the Peripheral Interrupts
  //INTERRUPT_PeripheralInterruptEnable();

  // Disable the Global Interrupts
  //INTERRUPT_GlobalInterruptDisable();

  // Disable the Peripheral Interrupts
  //INTERRUPT_PeripheralInterruptDisable();
 
  InitFaultHandler();
  InitConverter();

  //Interrupts must be enabled by hand
  GIE = 1;
  PEIE = 1;
  
  InitUARTsend();
  InitRampControl();
  InitSwitchController();
  
  PRG1_StartRampGeneration();  

  while (1)
  {
    //---------------------------Task scheduler---------------------------------    
    TaskCounter++;
    switch (TaskCounter)
    {
      //UART Rec handler
      case 1:
        task_RecUart();
      break;
      
      //UART Send handler
      case 2:
        UARTsend.SendTaskCounter++;
        if (UARTsend.SendTaskCounter > 10)
        {  
          task_SendUart();
          UARTsend.SendTaskCounter = 0;
        }
      break;
      
      //Vout handler
      case 3:
        task_CheckOutputVoltage(); 
      break;
      
      //Vin handler
      case 4:
        task_CheckInputUnderVoltage(); 
        task_CheckInputOverVoltage();
      break;
      
      //Switch handler
      case 5:
        task_CheckSwitch();
      break;
      
      //UART Rec handler
      case 6:
        task_RecUart();
      break;
      
      //Fault handler
      case 7:
        FaultHandler();
      break;
      
      //Temperature handler, no sensor
      case 8:
////        task_CheckTemperatureWarning();
      break;
      
      //xx handler
      case 9:
//        RC4 = 1;
        task_Animation ();
//        RC4 = 0;
      break;
      
      //xx handler
      case 10:
        TaskCounter = 0;
      break;
      
      //Default
      default:
        NOP();
      break;
    }   
    //---------------------------Task scheduler---------------------------------    
 
    // Wait for next task window 
    while (!INTCONbits.T0IF);
    INTCONbits.T0IF = 0;
    TMR0_Reload(); //time=100us
    
//    RC4 ^= 1;
  }//while1 end
}
/**
 End of File
 */