//19/02/2016 19:19:48/V3.1 Animation only

//-----------------------------------------------------------------------------
//  2015 Microchip Technology Inc. and its subsidiaries.  
//You may use this software and any derivatives exclusively with Microchip products. 
//  
//THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS".  NO WARRANTIES, WHETHER EXPRESS, 
//IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED WARRANTIES OF 
//NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A PARTICULAR PURPOSE, OR ITS 
//INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION WITH ANY OTHER PRODUCTS, OR 
//USE IN ANY APPLICATION. 
//
//IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL 
//OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED 
//TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS BEEN ADVISED OF THE 
//POSSIBILITY OR THE DAMAGES ARE FORESEEABLE.  TO THE FULLEST EXTENT ALLOWED BY 
//LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE 
//WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO 
//MICROCHIP FOR THIS SOFTWARE.
//
//MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE TERMS. 
//-----------------------------------------------------------------------------
#ifndef RAMPCONTROL_H
#define	RAMPCONTROL_H

#include <xc.h> // include processor files - each processor file is guarded.  
#include <stdint.h>
#include "globals.h"

extern void RampControll (RampControl_t *VRampControl_);
extern void RampControllOn (RampControl_t *VRampControl_);
extern void HazardControll (RampControl_t *VRampControl_);
extern void RampControllRampDown (RampControl_t *VRampControl_);
extern void RampControllWait (RampControl_t *VRampControl_);

//VOUT Ramp
#define MsTicksOnTime 100//240   //xxxms on time
#define MsTicksOffTime 290//250  //xxxms off time
#define MsTicksRampTime 200 //xxxms ramp

////#define RampStartVoltage_ 5
////#define RampStartVoltage  ((uint16_t)(RampStartVoltage_*19.3))  //19.32=1023/(25.8*2.048V))
#define RampStartVoltage  RampDACValues[0]//100

////#define RampEndVoltage_ 40
////#define RampEndVoltage  ((uint16_t)(RampEndVoltage_*19.3))  //19.32=1023/(25.8*2.048V))
#define RampEndVoltage  RampDACValues[199]//700

//RampEndVoltage-RampStartVoltage divided by MsTicksRampTime (200) must be an integer

#define RisingEdgeCount 3
#define RampRisingEdge  ((uint16_t)((RampEndVoltage-RampStartVoltage)/RisingEdgeCount))
#define RampRisingEdge  200

#define _16LEDs


//uint16_t RampDACValues[200];


const uint16_t RampDACValues[200] = 
//uint8_t RampDACValues[200] = 
{
#ifdef test
100	,
100	,
101	,
102	,
103	,
103	,
104	,
105	,
106	,
106	,
107	,
108	,
109	,
109	,
110	,
111	,
111	,
112	,
113	,
114	,
114	,
115	,
116	,
116	,
117	,
118	,
118	,
119	,
120	,
120	,
121	,
122	,
122	,
123	,
124	,
124	,
125	,
126	,
126	,
127	,
128	,
128	,
129	,
130	,
130	,
131	,
131	,
132	,
133	,
133	,
134	,
134	,
135	,
136	,
136	,
137	,
137	,
138	,
139	,
139	,
140	,
140	,
141	,
141	,
142	,
143	,
143	,
144	,
144	,
145	,
145	,
146	,
146	,
147	,
148	,
148	,
149	,
149	,
150	,
150	,
151	,
151	,
152	,
152	,
153	,
153	,
154	,
154	,
155	,
155	,
156	,
156	,
157	,
157	,
158	,
158	,
159	,
159	,
160	,
160	,
161	,
161	,
162	,
162	,
162	,
163	,
163	,
164	,
164	,
165	,
165	,
166	,
166	,
167	,
167	,
167	,
168	,
168	,
169	,
169	,
170	,
170	,
170	,
171	,
171	,
172	,
172	,
172	,
173	,
173	,
174	,
174	,
175	,
175	,
175	,
176	,
176	,
177	,
177	,
177	,
178	,
178	,
178	,
179	,
179	,
180	,
180	,
180	,
181	,
181	,
181	,
182	,
182	,
183	,
183	,
183	,
184	,
184	,
184	,
185	,
185	,
185	,
186	,
186	,
186	,
187	,
187	,
187	,
188	,
188	,
188	,
189	,
189	,
189	,
190	,
190	,
190	,
191	,
191	,
191	,
192	,
192	,
192	,
193	,
193	,
193	,
193	,
194	,
194	,
194	,
195	,
195	,
195	,
196	,
196	,
196	,
196	,
197	,
197	,
197	
#endif    
    
    
    
    
#ifdef _15LEDs
100	,
103	,
106	,
109	,
112	,
116	,
119	,
122	,
125	,
128	,
131	,
134	,
137	,
140	,
143	,
147	,
150	,
153	,
156	,
159	,
162	,
165	,
168	,
171	,
174	,
178	,
181	,
184	,
187	,
190	,
193	,
196	,
199	,
202	,
205	,
209	,
212	,
215	,
218	,
221	,
224	,
227	,
230	,
233	,
236	,
240	,
243	,
246	,
249	,
252	,
255	,
258	,
261	,
264	,
267	,
271	,
274	,
277	,
280	,
283	,
286	,
289	,
292	,
295	,
298	,
302	,
305	,
308	,
311	,
314	,
317	,
320	,
323	,
326	,
329	,
333	,
336	,
339	,
342	,
345	,
348	,
351	,
354	,
357	,
360	,
364	,
367	,
370	,
373	,
376	,
379	,
382	,
385	,
388	,
391	,
395	,
398	,
401	,
404	,
407	,
410	,
413	,
416	,
419	,
422	,
426	,
429	,
432	,
435	,
438	,
441	,
444	,
447	,
450	,
453	,
457	,
460	,
463	,
466	,
469	,
472	,
475	,
478	,
481	,
484	,
488	,
491	,
494	,
497	,
500	,
503	,
506	,
509	,
512	,
515	,
519	,
522	,
525	,
528	,
531	,
534	,
537	,
540	,
543	,
546	,
550	,
553	,
556	,
559	,
562	,
565	,
568	,
571	,
574	,
577	,
581	,
584	,
587	,
590	,
593	,
596	,
599	,
602	,
605	,
608	,
612	,
615	,
618	,
621	,
624	,
627	,
630	,
633	,
636	,
639	,
643	,
646	,
649	,
652	,
655	,
658	,
661	,
664	,
667	,
670	,
674	,
677	,
680	,
683	,
686	,
689	,
692	,
695	,
698	,
701	,
705	,
708	,
711	,
714	,
717	
#endif

#ifdef _16LEDs        
100	,
103	,
107	,
110	,
114	,
117	,
121	,
124	,
128	,
131	,
135	,
138	,
142	,
145	,
149	,
152	,
156	,
159	,
163	,
166	,
170	,
173	,
177	,
180	,
184	,
187	,
191	,
194	,
198	,
201	,
205	,
208	,
212	,
215	,
219	,
222	,
226	,
229	,
233	,
236	,
240	,
243	,
247	,
250	,
254	,
257	,
261	,
264	,
268	,
271	,
275	,
278	,
282	,
285	,
289	,
292	,
296	,
299	,
303	,
306	,
310	,
313	,
317	,
320	,
324	,
327	,
331	,
334	,
338	,
341	,
345	,
348	,
352	,
355	,
359	,
362	,
366	,
369	,
373	,
376	,
380	,
383	,
387	,
390	,
394	,
397	,
401	,
404	,
408	,
411	,
415	,
418	,
422	,
425	,
429	,
432	,
436	,
439	,
443	,
446	,
450	,
453	,
457	,
460	,
464	,
467	,
471	,
474	,
478	,
481	,
485	,
488	,
492	,
495	,
499	,
502	,
506	,
509	,
513	,
516	,
520	,
523	,
527	,
530	,
534	,
537	,
541	,
544	,
548	,
551	,
555	,
558	,
562	,
565	,
569	,
572	,
576	,
579	,
583	,
586	,
590	,
593	,
597	,
600	,
604	,
607	,
611	,
614	,
618	,
621	,
625	,
628	,
632	,
635	,
639	,
642	,
646	,
649	,
653	,
656	,
660	,
663	,
667	,
670	,
674	,
677	,
681	,
684	,
688	,
691	,
695	,
698	,
702	,
705	,
709	,
712	,
716	,
719	,
723	,
726	,
730	,
733	,
737	,
740	,
744	,
747	,
751	,
754	,
758	,
761	,
765	,
768	,
772	,
775	,
779	,
782	,
786	,
789	,
793	,
796	
#endif
}


#endif	/* RAMPCONTROL_H */

