/* *****************************************************************************************************
 * SOFTWARE COPYRIGHT NOTICE 
 *  
 * (c) 2016 Microchip Technology Inc. and its subsidiaries.  
 * You may use this software and any derivatives exclusively with Microchip products. 
 * 
 * THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED OR 
 * STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED WARRANTIES OF NON-INFRINGEMENT, 
 * MERCHANTABILITY, AND FITNESS FOR A PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, 
 * COMBINATION WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION. 
 * 
 * IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL OR CONSEQUENTIAL 
 * LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN 
 * IF MICROCHIP HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE.  TO THE FULLEST 
 * EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY WAY RELATED TO THIS 
 * SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR 
 * THIS SOFTWARE.
 * 
 * MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE TERMS. 
 * ****************************************************************************************************/

/* 
 * File:   
 * Author: 
 * Comments:
 * Revision history: 
 */

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef APPLICATION_LAYER_TASKS_H
#define	APPLICATION_LAYER_TASKS_H

#include <xc.h> // include processor files - each processor file is guarded.  
#include <stdint.h>
#include "globals.h"

/* Scheduler Tasks */
////extern void task_Idle(void); // Task ID = 0
extern void task_CheckInputUnderVoltage(void); // Task ID = 1
extern void task_CheckInputOverVoltage(void); // Task ID = 2
extern void task_CheckOutputVoltage(void); // Task ID = 3
////extern void task_CheckForwardCurrent(void); // Task ID = 4
extern void task_CheckTemperatureWarning(void); // Task ID = 5
////extern void task_CheckTemperatureProtection(void); // Task IS = 6
extern void task_CheckSwitch(void); // Task ID = 7
extern void task_SetDimmingDutyRatio(void); // Task ID = 8
////extern void task_SetForwardCurrentRefrence(void); // Task ID = 9
////extern void ssm_mode_triangular(void); // Task ID = 10
////extern void task_CheckOperationModeStatus(void); // Task ID = 11
extern void task_SendUart(void);    // Task ID = 12
extern void task_RecUart(void);    // Task ID = 13

/* Additional Tasks */
////extern void SYSTEM_Initialize_(void);
////extern void InitScheduler(void);

extern void InitUARTsend(void);
extern void InitRampControl (void);
extern void task_Animation (void);

extern void InitSwitchController(void);
////extern void GetBIN(void); 

//------------------------------------------------------------------------------
// Task Table lists all tasks which will be called by the scheduler/task manager
//------------------------------------------------------------------------------
// This is the list which defines all tasks as enumerated items of an array
// These enumerations will be combined freely in task flow lists
// which will then be called by the scheduler function calls in 
// the main loop

////void (*Task_Table[])(void) = {
////	task_Idle,                      // TASK_IDLE = 0,
////	task_CheckInputUnderVoltage,    // TASK_CHK_VIN = 1,
////	task_CheckInputOverVoltage,     // TASK_CHK_VIN = 2,
////	task_CheckOutputVoltage,        // TASK_CHK_VOUT = 3,
////	task_CheckForwardCurrent,       // TASK_CHK_IFWD = 4, (reserved, not implemented)
////	task_CheckTemperatureWarning,   // TASK_CHK_TEMP = 5,
////	task_CheckTemperatureProtection,// TASK_CHK_TEMP = 6,
////	task_CheckSwitch,               // TASK_CHK_BUTTON = 7,
////	ssm_mode_triangular,            // TASK_SPREAD_SPECTRUM = 8,
////	task_SetDimmingDutyRatio,       // TASK_SET_DIMM_RATIO = 9,
////	task_SetForwardCurrentRefrence, // TASK_SET_IFWD_REF = 10,
////	task_CheckOperationModeStatus,  // TASK_CHK_OP_MODE_STATE = 11,
////    FaultHandler,                    // FaultHandler = 12   
////    task_SendUart
////};




#endif	/* APPLICATION_LAYER_TASKS_H */

